from pylab import *
import time

import matplotlib.backends
import matplotlib.pyplot as p
import os.path

'''
Call and output:
SASkia> @@mplbackends
Start python script:  /home/almut/python/cmd2/sascur/scripts/mplbackends.py
supported backends:
['agg', 'pgf', 'svg', 'cairo', 'tkagg', 'mixed', 'gtk3', 'webagg', 'qt4', 'gtk3agg', 'ps', 'gtk3cairo', 'gdk', 'gtk', 'pdf', 'gtkagg', 'macosx', 'wx', 'qt4agg', 'cocoaagg', 'wxagg', 'template', 'gtkcairo']
valid backends:
['agg', 'pgf', 'svg', 'cairo', 'tkagg', 'webagg', 'ps', 'gdk', 'gtk', 'pdf', 'gtkagg', 'qt4agg', 'template', 'gtkcairo']
       agg FPS:   35.4
       pgf FPS: 2839.2  # The fast ones (high FPS) cannot be caught by the eye
       svg FPS: 2853.1
     cairo FPS: 2859.8
     tkagg FPS:   24.6
    webagg FPS:   34.9
        ps FPS: 2833.5
       gdk FPS: 2853.7
       gtk FPS:   24.9
       pdf FPS: 2856.3
    gtkagg FPS:   27.7
    qt4agg FPS:   35.1
  template FPS:   40.9
  gtkcairo FPS:   21.3
-------------------------------------------------------------------------------
SASkia> Fatal Python error: (pygame parachute) Segmentation Fault
/home/almut/bin/sc: Zeile 3: 11799 Abgebrochen             (Speicherabzug geschrieben) python ~/python/cmd2/sascur/saskia.py $*
  We have been warned that it will crash finally.
'''


def is_backend_module(fname):
    """Identifies if a filename is a matplotlib backend module"""
    return fname.startswith('backend_') and fname.endswith('.py')

def backend_fname_formatter(fname):
    """Removes the extension of the given filename, then takes away the leading 'backend_'."""
    return os.path.splitext(fname)[0][8:]

# get the directory where the backends live
backends_dir = os.path.dirname(matplotlib.backends.__file__)

# filter all files in that directory to identify all files which provide a backend
backend_fnames = filter(is_backend_module, os.listdir(backends_dir))

backends = [backend_fname_formatter(fname) for fname in backend_fnames]

print("supported backends:\n%s"%backends)

# validate backends
backends_valid = []
for b in backends:
    try:
        p.switch_backend(b)
        backends_valid += [b]
    except:
        continue

print("valid backends:\n%s"%backends_valid)


# try backends performance
for b in backends_valid:

    ion()
    try:
        p.switch_backend(b)


        clf()
        tstart = time.time()               # for profiling
        x = arange(0,2*pi,0.01)            # x-array
        line, = plot(x,sin(x))
        for i in arange(1,200):
            line.set_ydata(sin(x+i/10.0))  # update the data
            draw()                         # redraw the canvas
        fps = 200/(time.time()-tstart)
        print('%10s FPS: %6.1f'%(b,fps))
        #print(b + ' FPS: \t' , 200/(time.time()-tstart))
        ioff()

    except:
        print('%10s error:('%b)
        #print(b + " error :(")
